%define pkgname   kqemu
%define modname   qemu
%define modver    1.4.0
%define modrel    pre1
%define kernver   2.6.18-128.7.1.el5
%define kernstr   %(echo %{kernver} | tr '-' '_')

%define modtop    addon
%define moddir    %{modtop}/misc

%define PAE       1
%define xen       1


Summary:          The QEMU Accelerator Module
Name:             %{modname}-kmod
Version:          %{modver}
Release:          0.1.%{modrel}.%{kernstr}%{?pext}
License:          GPL
Group:            System Environment/Kernel
Source0:          http://www.nongnu.org/%{modname}/%{pkgname}-%{modver}%{modrel}.tar.gz
URL:              http://www.nongnu.org/%{modname}/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           Fabrice Bellard
ExclusiveArch:    i686 x86_64

%description
The QEMU Accelerator (KQEMU) is a driver allowing the QEMU PC emulator
to run much faster when emulating a PC on an x86 host. It is supported
on x86 or x86_64 Linux 2.4 or 2.6 hosts.


%package       -n kmod-%{modname}
Summary:          QEMU kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-%{_target_cpu} = %{kernver}
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
BuildRequires:    kernel-devel-%{_target_cpu} = %{kernver}

%description   -n kmod-%{modname}
This package provides the QEMU kernel modules built for the Linux kernel
%{kernver} for the %{_target_cpu} family of processors.


%package       -n kmod-%{modname}-PAE
Summary:          QEMU kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}PAE
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-PAE-%{_target_cpu} = %{kernver}
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
%if %{PAE}
%ifarch i686
BuildRequires:    kernel-PAE-devel-%{_target_cpu} = %{kernver}
%endif
%endif

%description   -n kmod-%{modname}-PAE
This package provides the QEMU kernel modules built for the Linux kernel
%{kernver}PAE for the %{_target_cpu} family of processors.


%package       -n kmod-%{modname}-xen
Summary:          QEMU kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}xen
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-xen-%{_target_cpu} = %{kernver}
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
%if %{xen}
BuildRequires:    kernel-xen-devel-%{_target_cpu} = %{kernver}
%endif

%description   -n kmod-%{modname}-xen
This package provides the QEMU kernel modules built for the Linux kernel
%{kernver}xen for the %{_target_cpu} family of processors.


%prep
%setup -q -n %{pkgname}-%{modver}%{modrel}


%build
BuildModule() {
  # Prepare environment
  if [ -n "$2" ]; then
    echo "BUILDING MODULE FOR $2 $1 KERNEL..."
    config="$2-$1"
  else
    echo "BUILDING MODULE FOR up $1 KERNEL..."
    config="$1"
  fi

  # Build module
  %{__make} clean || :

  %configure \
	--kernel-path=%{_usrsrc}/kernels/%{kernver}-${config}

  %{__make} \
	all

  %{__mv} %{pkgname}.ko %{modname}-${config}.mod
}

%if %{PAE}
%ifarch i686
BuildModule %{_target_cpu} PAE
%endif
%endif

%if %{xen}
BuildModule %{_target_cpu} xen
%endif

BuildModule %{_target_cpu}


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_prefix}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}PAE/%{moddir}/%{modname}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}xen/%{moddir}/%{modname}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}/%{moddir}/%{modname}

%if %{PAE}
%ifarch i686
%{__install} -m 0744 %{modname}-PAE-%{_target_cpu}.mod \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}PAE/%{moddir}/%{modname}/%{pkgname}.ko
%endif
%endif

%if %{xen}
%{__install} -m 0744 %{modname}-xen-%{_target_cpu}.mod \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}xen/%{moddir}/%{modname}/%{pkgname}.ko
%endif

%{__install} -m 0744 %{modname}-%{_target_cpu}.mod \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}/%{moddir}/%{modname}/%{pkgname}.ko


%post -n kmod-%{modname}
/sbin/depmod -aeF /boot/System.map-%{kernver} %{kernver} >/dev/null || :

%post -n kmod-%{modname}-PAE
/sbin/depmod -aeF /boot/System.map-%{kernver}PAE %{kernver}PAE >/dev/null || :

%post -n kmod-%{modname}-xen
/sbin/depmod -aeF /boot/System.map-%{kernver}xen %{kernver}xen >/dev/null || :


%postun -n kmod-%{modname}
/sbin/depmod -aF /boot/System.map-%{kernver} %{kernver} &>/dev/null || :

%postun -n kmod-%{modname}-PAE
/sbin/depmod -aF /boot/System.map-%{kernver}PAE %{kernver}PAE &>/dev/null || :

%postun -n kmod-%{modname}-xen
/sbin/depmod -aF /boot/System.map-%{kernver}xen %{kernver}xen &>/dev/null || :


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files -n kmod-%{modname}
%defattr(744,root,root)
/lib/modules/%{kernver}/%{modtop}

%if %{PAE}
%ifarch i686
%files -n kmod-%{modname}-PAE
%defattr(744,root,root)
/lib/modules/%{kernver}PAE/%{modtop}
%endif
%endif

%if %{xen}
%files -n kmod-%{modname}-xen
%defattr(744,root,root)
/lib/modules/%{kernver}xen/%{modtop}
%endif


%changelog
* Sun Sep 06 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.4.0-0.1.pre1.2.6.18_128.7.1.el5
- New version (1.4.0pre1)

* Tue Aug 25 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.7.1.el5
- New kernel version (2.6.18-128.7.1.el5)

* Thu Aug 06 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.4.1.el5
- New kernel version (2.6.18-128.4.1.el5)

* Wed Jul 15 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.2.1.el5
- New kernel version (2.6.18-128.2.1.el5)

* Wed Jul 01 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.1.16.el5
- New kernel version (2.6.18-128.1.16.el5)

* Sun Jun 21 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.1.14.el5
- New kernel version (2.6.18-128.1.14.el5)

* Fri May 08 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.1.10.el5
- New kernel version (2.6.18-128.1.10.el5)

* Fri Apr 03 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.1.6.el5
- New kernel version (2.6.18-128.1.6.el5)

* Fri Apr 03 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.1.1.el5
- New kernel version (2.6.18-128.1.1.el5)

* Fri Apr 03 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_128.el5
- New kernel version (2.6.18-128.el5)

* Fri Dec 19 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_92.1.22.el5
- New kernel version (2.6.18-92.1.22.el5)

* Fri Nov 14 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_92.1.18.el5
- New kernel version (2.6.18-92.1.18.el5)

* Sat Nov 08 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_92.1.17.el5
- New kernel version (2.6.18-92.1.17.el5)

* Mon Oct 27 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_92.1.13.el5
- New kernel version (2.6.18-92.1.13.el5)

* Mon Oct 27 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_92.1.10.el5
- New kernel version (2.6.18-92.1.10.el5)

* Mon Oct 27 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-0.1.pre11.2.6.18_92.1.6.el5
- Initial build
